package TraceView::QueueMovies;
use SWF::Constants qw(:Text :Button :DisplayItem :Fill);
=item sub makeQueueMovies()

Reads directory and convert all found "queue-$nodeID.dat" files to FLASH-movies. (queue-$nodeID.swf)

I log every(?) event with queues and log it for every node. I modified 
	
	queue/queue.cc
	queue/queue.h
	queue/priqueue.cc
	tcl/lib/ns-default.tcl
	tcl/lib/..?
	..??
	
of NS-2 sources to make this work. Maybe not the most clever modification but works.

=cut

sub makeQueueMovies {
  my ($fontfile,$fullsimtime,$framefreq)=@_;
	print "fontfile=$fontfile\n";
	print "fullsimtime=$fullsimtime\n";
	print "framefreq=$framefreq\n";
	if (! -r $fontfile){ die("Couldn't read file $fontfile: $!");}

	print(STDERR "generating QueueMovies:\n");
	opendir(DIR, "$main::dir");
	# only files starting with "queue-" and ending with ".dat" ..
	my @files= grep { /^queue-/} grep {/.dat$/} readdir(DIR);
	
	
	foreach my $name (@files) {
		print(STDERR "  found ".$name." ");
		open(QUEUE, "$main::dir/$name") or &main::sendError("Couldn't open $main::dir/$name. $! .Maybe wrong file permissions?\n");
		my @file=<QUEUE>;
		close(QUEUE);
		my $nodeid = $name;
		$nodeid =~ s/\.dat$//;
		$nodeid =~ s/^queue-//;
		print(STDERR "id:".$nodeid." ");
		#-movie
		# |-window ('window')
		#   |-mask
		#   |-coord ('coord')       
		#     |-background
		#     |-grid
		#     |-redline
		#     |-graph
		# |-title
		# |-buttonclose
		# |-buttonzoomout
		# |-buttonzoomin
		#write 1 swf-file for every queue
		
		#extra, global $font not working, is it my fault?? help please
		my $font = new SWF::Font("$fontfile");
		
		my $movie = new SWF::Movie();
		my $moviex=400;
		my $moviey=200;
		$movie->setDimension($moviex,$moviey);
		#$movie->setRate(1.0); # always ignored when loaded by the mainmovie
		
		my $window = new SWF::MovieClip();
		my $coord = new SWF::MovieClip();
		
		# mask	
		my $mask = &main::makerect(0xff, 0xcc, 0xcc, 0xff, $moviex+2, 202,0);	
		my $mask_inst = $window->add($mask);	
		$mask_inst->setMaskLevel(3);
		
		#background for diagram
		my $rect = &main::makerect(0xff, 0xee, 0xee, 0xff, $moviex, $moviey,0);	
		my $rect_inst = $coord->add($rect);
		
		#graph
		my $graph = new SWF::Shape();
		$graph->setLine(1, 0, 0, 0);
  	$graph->movePenTo(0,200);
		my $simtime=0.0;
		my $lastlength=0; 
		my $length=0;
		my $lasttime=0;
		my $stepsize=2; # 2 pixel pro queueentry (wenn max 100 pakete und Hoehe 200 pixel) 
		my $decade=$stepsize*10;
		
		#grid
		my $grid = new SWF::Shape();
		$grid->setLine(1, 0x99, 0x99, 0x99);		
		for (my $i=0;$i<=4;$i++){
			$grid->movePenTo(0,200-$decade*$i);
			$grid->drawLineTo($moviex,200-$decade*$i);		
		}
		my $grid_inst = $coord->add($grid);
		
				
		SWF::setScale(1);
		foreach my $row (@file)
		{	my @line;
			@line = split(/ /,$row);
			# problems when simtime in exponential form(e.g. 2.5e-05) . no problem for perl, but ming-0.2a. :-(
			$simtime=$line[0];
			$length=$line[1];
			my $xshift=$simtime*$moviex*20/$fullsimtime;
			#print(STDERR $simtime." ". $xshift."\n");
			
			$graph->drawLineTo($xshift,4000-$lastlength*20*$stepsize);
			$graph->movePenTo($xshift,4000);
			if ($length>$lastlength) {$graph->drawLineTo($xshift,4000-$length*20*$stepsize); }
			else{	
				$graph->drawLineTo($xshift,4000-$lastlength*20*$stepsize);
				$graph->movePenTo($xshift,4000-$length*20*$stepsize);
			}
			
			#print(STDERR $simtime."last: ".$lastlength."\n");
			#print(STDERR $simtime."now:  ".$length."\n");
			$lasttime=$simtime;
			$lastlength=$length;
		}
		SWF::setScale(20); #set it back to default
		
		my $graph_inst=$coord->add($graph);
				
		#timeline for queue
		my $redlineshape=new SWF::Shape();
		$redlineshape->setLine(1, 0xff, 0, 0);
		$redlineshape->drawLineTo(0, 200);
		my $redline= new SWF::MovieClip();
		$redline->add($redlineshape);
				
		my $scalefactor=$moviex/($fullsimtime * $framefreq);
		$redline->add(new SWF::Action("this._x = _root.viewport.view._currentFrame * $scalefactor;"));
		$redline->nextFrame();
		$redline->nextFrame();
		my $redline_inst=$coord->add($redline);
		
		$coord->nextFrame();
		
		my $coord_inst = $window->add($coord);
		$coord_inst->setName('coord');
		$window->nextFrame();
		
		my $window_i = $movie->add($window);
		$window_i->setName('window');
		
			
		#text for title
		my $title= new SWF::Text();
		$title->setFont($font);
		$title->setHeight(14);
		$title->setColor(0x00, 0x00, 0);
		$title->addString("Queue Node $nodeid");

		my $title_inst = $movie->add($title);
		$title_inst->moveTo(140,20);
				
		## closequeue
		my $closebutton = new SWF::Button();
		my $closeshape = &main::makeClose(0xcc, 0xcc, 0xcc, 0xff,10, 10,1);
		my $closeshape2 = &main::makeClose(0xee, 0xee, 0xee, 0xff,10, 10,1);
		$closebutton->addShape($closeshape, SWFBUTTON_UP|SWFBUTTON_HIT);
		$closebutton->addShape($closeshape2, SWFBUTTON_DOWN|SWFBUTTON_OVER);
		$closebutton->addAction(new SWF::Action("unloadMovie('this');"), SWFBUTTON_MOUSEUP);
		my $closebutton_inst = $movie->add($closebutton);
		$closebutton_inst->moveTo(1,1);
		
		# zoom out
		my $zoomoutbutton = new SWF::Button();
		my $zoomoutshape = &main::makeZoomout(0xcc, 0xcc, 0xcc, 0xff, 10, 10,1);
		my $zoomoutshape2 = &main::makeZoomout(0xee, 0xee, 0xee, 0xff, 10, 10,1);
		$zoomoutbutton->addShape($zoomoutshape, SWFBUTTON_UP|SWFBUTTON_HIT);
		$zoomoutbutton->addShape($zoomoutshape2, SWFBUTTON_DOWN|SWFBUTTON_OVER);
		$zoomoutbutton->addAction(new SWF::Action("window.coord._xScale = window.coord._xScale / 2;"), SWFBUTTON_MOUSEUP);
		my $zoomoutbutton_inst = $movie->add($zoomoutbutton);
		$zoomoutbutton_inst->moveTo(13,1);
		
		# zoom in
		my $zoominbutton = new SWF::Button();
		my $zoominshape = &main::makeZoomin(0xcc, 0xcc, 0xcc, 0xff, 10, 10,1);
		my $zoominshape2 = &main::makeZoomin(0xee, 0xee, 0xee, 0xff, 10, 10,1);
		$zoominbutton->addShape($zoominshape, SWFBUTTON_UP|SWFBUTTON_HIT);
		$zoominbutton->addShape($zoominshape2, SWFBUTTON_DOWN|SWFBUTTON_OVER);
		$zoominbutton->addAction(new SWF::Action("window.coord._xScale = 2 * window.coord._xScale;"), SWFBUTTON_MOUSEUP);
		my $zoominbutton_inst = $movie->add($zoominbutton);
		$zoominbutton_inst->moveTo(25,1);	

		$movie->nextFrame(); # frame 1 ok
		$name=~ s/\.dat$/\.swf/;
		print(STDERR "write $main::dir/$name\n");
		$movie->save("$main::dir/$name");
	}
	closedir(DIR);
	
}

1;
