package TraceView::SampleMovies;
use SWF::Constants qw(:Text :Button :DisplayItem :Fill);
# for te scale
use POSIX ("log10");

#require ("./traceview-gui.pl");

=item sub makeSampleMovies()


	SampleMovies are made of all samples-NodeID-NeighborID.dat in the directory.
	I log every received HELLO-Messages in AODV. I changed AODV-protocol of ns-2 version 2.1b9. 
	Possible would be measuring of all received packets, but HELLO-Messages come in relative constant timeintervals
	and are not too many. :-) 
	
	1 HELLO/sec, if signal>RxThresh and medium (MAC802.11) not too overloaded or blocked by other mobile nodes.

=cut

sub makeSampleMovies {
	my ($fontfile,$fullsimtime,$framefreq)=@_;
	print "fontfile=$fontfile\n";
	print "fullsimtime=$fullsimtime\n";
	print "framefreq=$framefreq\n";

	if (! -r $fontfile) {die("Couldn't read file $fontfile: $!");}
	print(STDERR "generating SampleMovies:\n");
	opendir(DIR, "$main::dir");
	#only files starting with "samples-" and ending with ".dat" ..
	my @files= grep {/^samples-/} grep {/.dat$/} readdir(DIR);


	foreach my $name (@files) {
		print(STDERR "  found $main::dir/$name ");
		open(SAMPLES, "$main::dir/$name") or &main::sendError("Couldn't open $main::dir/$name. Maybe wrong file permissions?\n");
		my @file=<SAMPLES>;
		close(SAMPLES);
		
		my $nodeid = $name;
		# format "samples-15-3.dat"
		$nodeid =~ s/\.dat$//;
		$nodeid =~ s/^samples-//;
		#now "15-3"
		($nodeid,my $neighbor) = split(/-/,$nodeid);
		#-movie
		# |-window ('window')
		#   |-mask
		#   |-coord ('coord')       
		#     |-background
		#     |-grid
		#     |-redline
		#     |-graph
		# |-buttonclose
		# |-buttonzoomout
		# |-buttonzoomin
		
		# write 1 swf-file for every neighbor of every node
		my $movie = new SWF::Movie();
		my $moviex=400;
		my $moviey=200;
		$movie->setDimension($moviex,$moviey+20);
		$movie->setRate(1.0); # 1 frame per second, only used if you view the sample-swf's direct.
		
		
		my $window = new SWF::MovieClip();
		my $coord = new SWF::MovieClip();
		my $coordText = new SWF::MovieClip();
		
		# a mask activate if you want
		#my $mask = &makerect(0xff, 0xcc, 0xcc, 0xff, $moviex+2, 202,0);	
		#my $mask_inst = $window->add($mask);	
		#$mask_inst->setMaskLevel(3);
		
		# backgroundrect:	light green for neighborsamples 
		# green=positive, friendly, our neighbors :-) 
		my $rect = &main::makerect(0xee, 0xff, 0xee, 0xff, $moviex, $moviey,0);	
		my $rect_inst = $coord->add($rect);
		
		#extra
		my $font = new SWF::Font("$fontfile");
		
		#grid
		my $grid = new SWF::Shape();
		$grid->setLine(1, 0x99, 0x99, 0x99);
		my $decade=50;
		
		#grid for x		
		for (my $i=1;$i<=7;$i++){
			$grid->movePenTo(50*$i,$moviey);
			$grid->drawLineTo(50*$i,0);
		}
			
		#grid for y
		for (my $i=0;$i<=3;$i++){
			$grid->movePenTo(0,$moviey-$decade*$i);
			$grid->drawLineTo($moviex,$moviey-$decade*$i);
			$grid->movePenTo(0,$moviey-$decade*($i+0.5));
			$grid->drawLineTo($moviex,$moviey-$decade*($i+0.5));
				
			#old logarithmic scale, now all in dBm
			#$grid->movePenTo(0,200-$decade*$i-$decade*log10(5));
			#$grid->drawLineTo($moviex,200-$decade*$i-$decade*log10(5));			
		}
		
		
		SWF::setScale(1);
			# draw threshold parameters of default mobile node in ns-2
			$grid->setLine(1, 0x99, 0, 0);
			my $receivethreshold=3.652e-10;
			my $receivethreshold_bdm=10*log10(3.652e-10/.001); # -64 dBM		
			# -30 dBm upper border
			my $ypos=-20*$decade*($receivethreshold_bdm/10+3);
			$grid->movePenTo (20*0, $ypos);
			$grid->drawLineTo(20*$moviex, $ypos);	
			my $RThresh= new SWF::Text();
			$RThresh->setFont($font);
			$RThresh->setHeight(240);
			$RThresh->setColor(0x99,0,0);
			$RThresh->addString("ReceiveThreshold(ns2 default)");
			my $RThresh_i = $coordText->add($RThresh);
			#$RThresh_i->move(0,$ypos);
			$RThresh_i->move(0,$ypos);
		SWF::setScale(20);
		
		
		# ToDO:text for x-axe; put a little bit below graph
		#my $coordXnumber= new SWF::Text();


		my $grid_inst = $coord->add($grid);
		
		#text for y-axe
		for (my $i=0;$i<=4;$i++){
			my $coordYnumber= new SWF::Text();
			$coordYnumber->setFont($font);
			$coordYnumber->setHeight(12);
			$coordYnumber->setColor(0xcc,0,0);
			my $ystring = (10 ** $i)/10e9 ;
			if ($i==0) {$ystring="-70 dBm"};  #if ($i==0) {$ystring="0.1 nW"}; # 1e-10W
			if ($i==1) {$ystring="-60 dBm"};  #if ($i==1) {$ystring="  1 nW"};
			if ($i==2) {$ystring="-50 dBm"};  #if ($i==2) {$ystring=" 10 nW"};
			if ($i==3) {$ystring="-40 dBm"};  #if ($i==3) {$ystring="100 nW"};
			if ($i==4) {$ystring="-30 dBm"};  #if ($i==4) {$ystring="  1 uW"};  
			$coordYnumber->addString("$ystring");
			my $coordYnumber_i = $coordText->add($coordYnumber);
			my $pos=200-$decade*$i;
			#print(STDERR '$i='.$i.' $ystring='.$ystring.' pos='.$pos."\n");
			$coordYnumber_i->move(0,$pos);	
		}

		my $graph = new SWF::Shape();
			$graph->setLine(1, 0, 0, 0);
  		$graph->movePenTo(0,0);
		my $simtime=0.0;
		my $lastsample=0; 
		my $sample=0;
		my $lasttime=0;
		
		
		#important: changed Scale to avoid stairs effect (ming-bug - aeh - "feature")   
		SWF::setScale(1);
		foreach my $row (@file)
		{	my @line;
			@line = split(/ /,$row);
			$simtime=$line[0];
			$sample=$line[1];
			chomp($sample);
			my $xshift=$simtime*$moviex*20/$fullsimtime;
			
			# the "20" is because we calc in twips. hack!
			# If you want pure linegraphs, comment next 2 lines.
			$graph->drawLineTo($xshift,-20*$decade*(log10($sample)+10));
			$graph->movePenTo($xshift,0);
			$graph->drawLineTo($xshift,-20*$decade*(log10($sample)+10));
			#$lasttime=$simtime;
			$lastsample=$sample;
		}
		#important: set back the Scale to default
		SWF::setScale(20);
		
		my $graph_inst = $coord->add($graph);
		$graph_inst->moveTo(0,200);		
		
		#timeline for samples
		my $redlineshape=new SWF::Shape();
		$redlineshape->setLine(1, 0xff, 0, 0);
		$redlineshape->drawLine(0, $moviey);
		my $redline= new SWF::MovieClip();
		$redline->add($redlineshape);
		
		
		my $scalefactor=$moviex/($fullsimtime * $framefreq);
		$redline->add(new SWF::Action("this._x = _root.viewport.view._currentFrame*$scalefactor;"));
		$redline->nextFrame();
		$redline->nextFrame();
		my $redline_inst=$coord->add($redline);
			
	$coord->nextFrame();
	$coordText->nextFrame();
		
		my $coord_inst = $window->add($coord);
		$coord_inst->setName('coord');
		my $coordText_inst = $window->add($coordText);
		$coordText_inst->setName('coordText');
		
		$window->nextFrame();
		
		my $window_i = $movie->add($window);
		$window_i->setName('window');
		
			
		#text for title
		my $title= new SWF::Text();
		$title->setFont($font);
		$title->setHeight(14);
		$title->setColor(0,0,0);
		$title->addString("Node $nodeid - Neighbor $neighbor");
		my $title_inst = $movie->add($title);
		$title_inst->moveTo(2,28);
		
		# close myself
		my $closebutton = new SWF::Button();
		my $closeshape = &main::makeClose(0xcc, 0xcc, 0xcc, 0xff,10, 10,1);
		my $closeshape2 = &main::makeClose(0xee, 0xee, 0xee, 0xff,10, 10,1);
		$closebutton->addShape($closeshape, SWFBUTTON_UP|SWFBUTTON_HIT);
		$closebutton->addShape($closeshape2, SWFBUTTON_DOWN|SWFBUTTON_OVER);
		$closebutton->addAction(new SWF::Action("unloadMovie('this');"), SWFBUTTON_MOUSEUP);
		my $closebutton_inst = $movie->add($closebutton);
		$closebutton_inst->moveTo(1,1);
		
		# zoom out
		my $zoomoutbutton = new SWF::Button();
		my $zoomoutshape = &main::makeZoomout(0xcc, 0xcc, 0xcc, 0xff, 10, 10,1);
		my $zoomoutshape2 = &main::makeZoomout(0xee, 0xee, 0xee, 0xff, 10, 10,1);
		$zoomoutbutton->addShape($zoomoutshape, SWFBUTTON_UP|SWFBUTTON_HIT);
		$zoomoutbutton->addShape($zoomoutshape2, SWFBUTTON_DOWN|SWFBUTTON_OVER);
		$zoomoutbutton->addAction(new SWF::Action("window.coord._xScale = window.coord._xScale / 2;"), SWFBUTTON_MOUSEUP);
		my $zoomoutbutton_inst = $movie->add($zoomoutbutton);
		$zoomoutbutton_inst->moveTo(13,1);
		
		# zoom in
		my $zoominbutton = new SWF::Button();
		my $zoominshape = &main::makeZoomin(0xcc, 0xcc, 0xcc, 0xff, 10, 10,1);
		my $zoominshape2 = &main::makeZoomin(0xee, 0xee, 0xee, 0xff, 10, 10,1);
		$zoominbutton->addShape($zoominshape, SWFBUTTON_UP|SWFBUTTON_HIT);
		$zoominbutton->addShape($zoominshape2, SWFBUTTON_DOWN|SWFBUTTON_OVER);
		$zoominbutton->addAction(new SWF::Action("window.coord._xScale = 2 * window.coord._xScale;"), SWFBUTTON_MOUSEUP);
		my $zoominbutton_inst = $movie->add($zoominbutton);
		$zoominbutton_inst->moveTo(25,1);	

		$movie->nextFrame(); # frame 1 ok
		
		$name=~ s/\.dat$/\.swf/;
		print(STDERR "write $main::dir/$name\n");
		$movie->save("$main::dir/$name");
	}
	closedir(DIR);
	
}

1;
