#!/usr/bin/perl -w

#-T taint flag temporarly deactivated due problems untainting my data (i'm too stupid and haven't time to fix it)

########################################
#  NS-2 TraceView                      #
#	 (c) 2003 Peter Liscovius            #
#                                      #
#  This software is under GPL licence. #
########################################

use strict;
use vars qw($nn $xsize $ysize $scaledxsize $scaledysize $moviex $moviey 
$fullsimtime $framefreq $routingproto $propagation $antenna $maxspeed
$infoshape $infoshape2 
$bshape $bshape2
$blshape $blshape2 
$closeShape $closeShape2 

$font $isweb $dir);

###################################
# start of custom configuration   #
#                                 #
# change vars to your needs       #
###################################

# Only if you installed the perl-ming module as normal user or not in the 
# standard perlhierarchy, give path to the SWF-module files.
# Where did you install perl-ming?
use lib("/aodv/bin/lib/site_perl");
#print $SWF::VERSION."\n";

# contains functions to paint some of the GUI-elements
require("./traceview-gui.pl");

# Calculates the stats for us if we haven't still calculated them.
use TraceStat;

# Defaultvalue: 10 frames in flash = 1 second in simulation, so a 100sec simulation has 1000 frames in flash, and a resolution of 1/10 sec.	
# Be careful, there are limitations of the flashfileformat and the filesize can grow fast. 
# If you set it to "auto" then traceview calculate the $framefrequency dependend from simulation time.
# It's a compromise between filesize and accuracy. This may change when we use full tracefile.tr 
# search on demand over the webserver with a fast searchalgoritm.
$framefreq="auto";
#my $framefreq=10; 

my $tracefilename="tracefile.tr";

# you need min 1 font in the .fdb format. Download or generate one from a flashmovie with the tool "makefdb" of ming-distribution if you haven't one.
#my $fontdir="/aodv/fonts";
my $fontdir="./fonts";

# 'convert' is part of ImageMagick (standardsoftware on unixlike computers i think)
# 'png2dbl' is in ming/util/ (http://ming.sourceforge.net)
my $mapimage = "map.dbl"; # 'convert -geometry $XSIZEx$YSIZE -negate environment.pnm map.png' , then 'png2dbl map.png'   


my $minx=500;


# path to gettable.pl. It must be a url like in <a href="/bla.htm">bla</a>
# because trcefile.tr.swf and gettable.pl are on the same server we don't need to
# give the domain/ip.
#my $tablescript="/cgi-bin/ns2/gettable.pl";
my $tablescript="/~peter/cgi-bin/ns2/gettable.pl";

# stripdirlevels:
# yeah let me explain:
# Assume all your simulations are written to directory /home/peter/sim or in
# deeper directories. traceview needs directory per simulation to compute
# useful output.
#
# The $basedir must be configured in gettable.pl.
#
# When we run traceview, the directory with the analyzed simulation is e.g.
# /home/peter/sim/newsims/out/nodes20
# So the $basedir is  /home/peter/sim
# and the $subdir is newsims/out/nodes20 (this path will be written into the tracefile.tr.swf)
# Because the first 3 levels of this path is the $basedir, we must set the 
# $stripdirlevels to 3. 
# The reason I do that is to avoid gettable.pl to read accidently in system 
# directories like the rootdir / or /etc and to avoid to let other 
# people know how your directories are organized.
my $stripdirlevels=5;

###################################
# end of custom configuration     #
###################################


# textlines between starting with = and a line with =cut are pod (plain-old-documentation) for perl
# try "pod2html trace.pl" for a HTML-documentation of this perl-program

=head1 NAME

NS-2 Wireless TraceViewer 
	
Currently only for a modified AODV-Routing protocol. But you are welcome to extend it to a more general tool.

=head1 FUNCTIONS

=cut


use File::Basename;

use SWF qw(:ALL);
use SWF::Constants qw(:Text :Button :DisplayItem :Fill);

#some global variable initialization
my $version="0.3.9";
$nn=0;
my $simtime=0;


# if you control traceview over the web:
if (defined $ENV{REQUEST_METHOD}) {
	$isweb=1;
	print "Content-type: text/html\n\n";
	
	use CGI;
	my $cgi = new CGI;
	$dir=$cgi->param("file") ;
	if ($dir eq "") { &sendIntro("You specified no parameters."); }
} else {

	if (!$ARGV[0]) { &sendError("\n   usage: ./traceview.pl /path/to/directory\n\nGive me a directory with ns2 simulation results.\nOnly for wireless simulations with AODV routing protocol with some enhancements.\n\n");}
	$dir=$ARGV[0];
}

# XXX fix me: always use a full path. no chdir calls here. make all too complicated.

print STDERR "$dir\n";
$dir =~ m/^([0-9\w\.\-\/_]+)$/ or &sendError('Nasty characters in argument for the specified directory? I only allow letters matched by "\w", ".", "0-9", "-", "_" and "/" characters.');
$dir = $1;

#If somebody started with a relative path we try to find the absolute path
chdir($dir);
print STDERR "$dir ".`pwd`."\n";
$dir=`pwd`;
chomp($dir);
chdir($ENV{PWD});

$main::tracefile="$dir/$tracefilename";
if (! -r $dir) {&sendError("Couldn't open directory $dir\n usage: traceview directory\n sample: ./traceview.pl ~/mysim/out/");}
if (! -r $main::tracefile) {&sendError("Couldn't open file $main::tracefile\n usage: traceview directory\n sample: ./traceview.pl ~/mysim/out/");}

# Now i can calculate all in pixels instead of 1/20 pixel steps
SWF::setScale(20);

# We want be sure we want to write an SWF6 Movie. We need SWF6 because we paint the routes
# with the SWF6 drawing API dependent of the current node positions and the received xml-files.
# All other features possible with F5 too. 
SWF::setVersion(6);

my $font = new SWF::Font("$fontdir/_sans.fdb");
# XXX FIXME stupid workaround for traceviewgui.pl
my $fontfile = "$fontdir/_sans.fdb";

#first we create some graphical object. Enables flash to reuse an objectshape and keep filesize down. 
&makeBasicObjects;

#run this first , because this file contains some overall infos for the other movies
&analyzeTracefile;


&makeHTML;
require("./traceview-makesamplemovies.pl");
require("./traceview-makequeuemovies.pl");
print "fullsimtime=$fullsimtime\nframefreq=$framefreq\n";

TraceView::QueueMovies::makeQueueMovies($fontfile,$fullsimtime,$framefreq);
TraceView::SampleMovies::makeSampleMovies($fontfile,$fullsimtime,$framefreq);
#&makeQueueMovies;
#&makeSampleMovies;

#&analyzeQueueFiles;
print "###############################################\n";
print " Congratulation: traceview analyzed your files.\n";
print "###############################################\n";
exit;
=over *

=item sub analyzeTraceFile()

Reads tracefile and write the main FLASH5-file and simple HTML-file.
	
Detect and provides global parameter from tracefile like "nodes", "area size", "simulation time". 
So it must be run first.  

=cut

sub analyzeTracefile {

	#print(STDERR "generating trace.swf:\n\n");

	# unixspecific
	my @last100 = `tail -100 $main::tracefile`;

	# Too dangerous when loading big files but faster when enough RAM to load the full file.
	#open(TRACEFILE,"$tracefile") or &sendError("Couldn't open file $tracefile .\n");
	#my @file=<TRACEFILE>;
	#close(TRACEFILE);
	
	my $lines=$#last100;
	my $lastline= $last100[$lines];
	my @lastline= split(/ /,$lastline);
	my $i=0;
	foreach (@last100) { 
	  #uh, now we must search backward to find regular new-trace entry.		 
		$lastline= $last100[$lines-$i];
		@lastline= split(/ /,$lastline);
		last if ($lastline[0] =~ /^[srfd]/ and $lastline[1]=~ /-t/ and $lastline[2]=~ /\d/);
		$i++;
		if ($i>=100) { &sendError("In the last 100 lines of $main::tracefile there is no regulasr new-trace entries.\n So I believe your tracefile is not a tracefile in new-trace format. Please use new-trace fileformat.\n"); }
	}
	$fullsimtime= $lastline[2];
	my $intfullsimtime=int($fullsimtime);
	if ($intfullsimtime != $fullsimtime) {
		#round up
		$fullsimtime = $intfullsimtime+1;
	}
	
	print(STDERR "Last regular new-trace entry: $lastline"); 
	if ($i >0) { print(STDERR "found $i line(s) before end of tracefile.\n");}
	print(STDERR "Full Simulation Time: $fullsimtime sec.\n");
	
	if ($framefreq eq "auto") { $framefreq=1000/$fullsimtime; }

	open(TRACEFILE,"$main::tracefile") or &sendError("Couldn't open file $main::tracefile .\n");

	# get infos from first 3 lines that contains some information about simulation setup
	# i will change this in fututre to a xml-ish line and parse the info by an xmlparser. 
	# so this is more flexible to changes of users TCL-script. 
	my @firstline=split(/ /,<TRACEFILE>);	
	my @line2=split(/ /,<TRACEFILE>);
	my @line3=split(/ /,<TRACEFILE>);
	close(TRACEFILE) or &sendError("Couldn't close file $main::tracefile .\n");
	
	# get some infos from first line
	if ($firstline[0] =~ /[^M]/ or $line2[0] =~ /[^M]/) {
		
		&sendError("\n".$main::tracefile.' does not start with an M configuration line!
Add something like

M 0.0 nn 20 x 500 y 500 rp AODV
M 0.0 sc /home/aodv/sim/movement.dat cp /home/aodv/sim/traffic.dat seed 0.0
M 0.0 prop Propagation/TwoRayGround ant Antenna/OmniAntenna

at the head of your tracefile. You can add this at your tcl-script:
		
puts $tracefd "M 0.0 nn $opt(nn) x $opt(x) y $opt(y) rp $opt(rp)"
puts $tracefd "M 0.0 sc $opt(sc) cp $opt(cp) seed $opt(seed)"
puts $tracefd "M 0.0 prop $opt(prop) ant $opt(ant)"

before 

puts "Starting Simulation...""); 
$ns_ run

');
	
}
	
	
	$nn=$firstline[3];
	$xsize=$firstline[5];
	$ysize=$firstline[7];
	$routingproto=$firstline[9];
	$propagation=$line3[3];
	$antenna=$line3[5];
	
	print(STDERR "Mobile Nodes: $nn\n");
	print(STDERR "Area: x=".$xsize."m y=".$ysize."m\n");
	print(STDERR "Propagation: $propagation\n");
	print(STDERR "Antenna: $antenna\n");
	# main movie
	my $movie = new SWF::Movie();
	# 2^16 / 20 = 3276.8 pixel = maximum width in flash
	my $maxx=1000; #3275 pixel
	my $factor=1;
	if($xsize < $minx){
		$factor=$minx/$xsize;
		$moviex=$xsize*$factor+20;
		$moviey=$ysize*$factor+80;
		$scaledxsize=$xsize*$factor;
		$scaledysize=$ysize*$factor;
	}
	elsif ($xsize > $maxx){
		$factor=$maxx/$xsize;
		$moviex=$xsize*$factor+20;
		$moviey=$ysize*$factor+80;
		$scaledxsize=$xsize*$factor;
		$scaledysize=$ysize*$factor;
	} 
	else {	
		$moviex=$xsize+20;
		$moviey=$ysize+80;
		$scaledxsize=$xsize;
		$scaledysize=$ysize;
	}
	print(STDERR "Movie: $moviex,$moviey\n");
	$movie->setDimension($moviex,$moviey);
	$movie->setRate(30.0);                    # up to 30 frames per second
	
	# P.L. 02.01.2003:directory subdir for gettable.pl. Absolute starting path is /aodv This may change.
	# traceview should detect this path. for now fixed address to 1 simulation.
	# XXX FIXME! $dir is full path.
	my $subdir="$dir";
	
  
	# cut leading directorypath.
	for (my $i=1 ;$i<=$stripdirlevels;$i++){
		$subdir=~ s/\/(\w+)(\/)/$2/;
	}
	print STDERR "$subdir.\n";
		
	$movie->add(new SWF::Action("subdir='$subdir'; framefreq='$framefreq'; tablescript='$tablescript';"));
	
	if($nn =~ /\d/ and $nn == int($nn) and $nn>=1 and $nn<=1000) {}
	else { &sendError("4th element of line 1 of tracefile maybe not contain the correct number of mobile nodes (between 0 and 1000). Check this please.\n");}
	if($xsize =~ /\d/ and $ysize =~ /\d/){}
	else { &sendError("6th and 8th element of line 1 of tracefile maybe not contain the simulationsize. Integervalues? Check this please.\n");}
		
	# paint coordinate system
	my $coord = new SWF::MovieClip();
	my $coordText = new SWF::MovieClip();		
	{
		my $coordlines = new SWF::Shape();
	
		# paint black rect around area
		$coordlines->setLine(1, 0, 0, 0);
		$coordlines->drawLineTo($scaledxsize, 0);
		$coordlines->drawLineTo($scaledxsize,-$scaledysize);
		$coordlines->drawLineTo(0,-$scaledysize);
		$coordlines->drawLineTo(0,0);
	
		#grid and numbers
		$coordlines->setLine(1, 0xee, 0xee, 0xee);
		my $raster=4; #gridcount
		my $rinv=1/$raster;
		
		my $coordZero= new SWF::Text();
		$coordZero->setFont($font);
		$coordZero->setHeight(11);
		$coordZero->setColor(0,0,0);
		$coordZero->addString("0 m");
		my $coordZero_i= $coordText->add($coordZero);
		$coordZero_i->move(-10,12);
			
		for (my $i=1;$i<=$raster;$i++) {
			my $x = $xsize*$rinv*$i;
			my $y = $ysize*$rinv*$i;
			my $scaledx = $scaledxsize*$rinv*$i;
			my $scaledy = $scaledysize*$rinv*$i;
			
			$coordlines->movePenTo($scaledx, 0);
			$coordlines->drawLineTo($scaledx,-$scaledysize) unless $i==$raster;
			
			my $coordXnumber= new SWF::Text();
			$coordXnumber->setFont($font);
			$coordXnumber->setHeight(11);
			$coordXnumber->setColor(0,0,0);
			$coordXnumber->addString("$x m");
			my $coordXnumber_i = $coordText->add($coordXnumber);
			my $coordXnumber_i2 = $coordText->add($coordXnumber);
			
			
			$coordlines->movePenTo(0,-$scaledy);
			$coordlines->drawLineTo($scaledxsize,-$scaledy) unless $i==$raster;
			
			my $coordYnumber= new SWF::Text();
			$coordYnumber->setFont($font);
			$coordYnumber->setHeight(11);
			$coordYnumber->setColor(0,0,0);
			$coordYnumber->addString("$y m");
			my $coordYnumber_i = $coordText->add($coordYnumber);
			#print(STDERR '$y='.$y.' $ysize='.$ysize."\n");
			if($i==$raster) {
				$coordXnumber_i->move($scaledx-25,12);
				$coordXnumber_i2->move($scaledx-25,-$scaledysize+12);
				$coordYnumber_i->move(4,-$scaledy+10);
			} 
			else{
				$coordXnumber_i->move($scaledx-8,12);
				$coordXnumber_i2->move($scaledx-8,-$scaledysize+12);
				$coordYnumber_i->move(4,-$scaledy+5);
			}
						

		}
		$coordText->nextFrame(); # finish object for numbers			
		
		$coord->add($coordlines);
		$coord->add($coordText);
		$coord->nextFrame(); # finish coordinate object
		
	}
	
	#textfield for time/frames
	my $frameText= new SWF::Text();
	$frameText->setFont($font);
	$frameText->setHeight(14);
	$frameText->setColor(0x00, 0x00, 0);
	$frameText->addString("Frame:");
	
	my $currentFrame = new SWF::TextField(SWFTEXTFIELD_DRAWBOX|SWFTEXTFIELD_HASLENGTH|SWFTEXTFIELD_NOEDIT|SWFTEXTFIELD_NOSELECT);
	$currentFrame->setBounds(35, 14);
	$currentFrame->setFont($font); 
	$currentFrame->setHeight(14);
	$currentFrame->setColor(0x00, 0x00, 0x00, 0xff);
	$currentFrame->setAlignment(SWFTEXTFIELD_ALIGN_RIGHT);
	$currentFrame->setName('cf');
	
	my $timeText= new SWF::Text();
	$timeText->setFont($font);
	$timeText->setHeight(14);
	$timeText->setColor(0x00, 0x00, 0);
	$timeText->addString("Time:");
	
	my $timesec= new SWF::Text();
	$timesec->setFont($font);
	$timesec->setHeight(14);
	$timesec->setColor(0x00, 0x00, 0);
	$timesec->addString("s");
	
	my $currentTime = new SWF::TextField(SWFTEXTFIELD_DRAWBOX|SWFTEXTFIELD_HASLENGTH|SWFTEXTFIELD_NOEDIT|SWFTEXTFIELD_NOSELECT);
	$currentTime->setBounds(40,14);
	$currentTime->setFont($font); 
	$currentTime->setHeight(14);
	$currentTime->setColor(0x00, 0x00, 0x00, 0xff);
	$currentTime->setAlignment(SWFTEXTFIELD_ALIGN_RIGHT);
	$currentTime->setName('ct');
	
	# show fullsimtime at end of slider
	my $totalFrames = new SWF::Text();
	$totalFrames->setFont($font);
	$totalFrames->setHeight(12);
	$totalFrames->setColor(0, 0, 0, 0xff);
	$totalFrames->addString($fullsimtime);
	
	# contains several textfields
	my $tfields = new SWF::MovieClip();  # 2 frames
	$tfields->add(new SWF::Action("cf=_root.viewport.view._currentFrame; ct=cf/$framefreq;"));
	
	my $frameText_inst=$tfields->add($frameText); 
	$frameText_inst->moveTo(150,25);
	my $currentFrame_inst = $tfields->add($currentFrame);
	$currentFrame_inst->moveTo(200,12);
	my $timeText_inst=$tfields->add($timeText); 
	$timeText_inst->moveTo(240,25);	
	my $currentTime_inst =  $tfields->add($currentTime);
	$currentTime_inst->moveTo(280,12);
	my $timesec_inst=$tfields->add($timesec); 
	$timesec_inst->moveTo(325,25);
	
	my $totalFrames_inst =  $tfields->add($totalFrames);
	
	my $sliderlength=$moviex-20;
	$totalFrames_inst->moveTo($sliderlength-10,37);
	
	$tfields->nextFrame(); #fr 1 ok
	$tfields->nextFrame(); #fr 2 ok

	# timeline/slider
	my $background=&makerect(0xee, 0xee, 0xee, 0xff, $sliderlength, 10, 1);
	my $line=new SWF::Shape();
	$line->setLine(1, 0xff, 0, 0);
	$line->drawLineTo(0, 10);
	my $sclip= new SWF::MovieClip();
	$sclip->add($line);
	
	
	my $scalefactor=$sliderlength/($fullsimtime * $framefreq);
	$sclip->add(new SWF::Action("this._x = _root.viewport.view._currentFrame * $scalefactor;"));
	$sclip->nextFrame();
	$sclip->nextFrame();
	
	my $timeline= new SWF::MovieClip();
	$timeline->add($background);
	my $sclip_inst=$timeline->add($sclip);
	$sclip_inst->setName("line");
	$timeline->nextFrame();	
	
	# stop button
	my $stop = new SWF::Button();
	my $stopshape=&makestop(0xdd, 0xdd, 0xdd, 30, 30);
	my $stopshape2=&makestop(0xff, 0xcc, 0x33, 30, 30);
	$stop->addShape($stopshape, SWFBUTTON_UP|SWFBUTTON_HIT);
	$stop->addShape($stopshape2, SWFBUTTON_OVER|SWFBUTTON_DOWN);
	$stop->addAction(new SWF::Action("
_root.viewport.view.isplaying=0;
_root.viewport.view.gotoandstop(1);	
	"), SWFBUTTON_MOUSEUP);	
	
	# pause button
	my $pause = new SWF::Button();
	my $pauseshape=&makepause(0xdd, 0xdd, 0xdd, 30, 30);
	my $pauseshape2=&makepause(0xff, 0xcc, 0x33, 30, 30);
	$pause->addShape($pauseshape, SWFBUTTON_UP|SWFBUTTON_HIT);
	$pause->addShape($pauseshape2, SWFBUTTON_OVER|SWFBUTTON_DOWN);
	$pause->addAction(new SWF::Action("
this.gotoandstop(1);
_root.viewport.view.isplaying=0;
_root.viewport.view.stop();

	"), SWFBUTTON_MOUSEUP);
	
	# play button
	my $play = new SWF::Button();
	my $playshape=&makePlay(30, 30, 0xdd, 0xdd, 0xdd);
	my $playshape2=&makePlay(30,30, 0xff, 0xcc, 0x33);
	$play->addShape($playshape, SWFBUTTON_UP|SWFBUTTON_HIT);
	$play->addShape($playshape2, SWFBUTTON_OVER|SWFBUTTON_DOWN);
	$play->addAction(new SWF::Action("
view =_root.viewport.view;
view.isplaying=1;

//reactivate stopped timers.
if (_root.autoupdate == 1){
	for (var i=0;i<$nn;i++){
		if (view.nb[i]._visible == 1){
			view[i].nbrestart();
		}
		if (view.rt[i]._visible == 1){
			view[i].rtrestart();
		}
	}
}
if (view._currentFrame == view._totalFrames){
  view.gotoandplay(2);
}
else {
	_root.viewport.view.play();
}
this.gotoandstop(2);
"), SWFBUTTON_MOUSEUP);

	
	#zoom buttons
	my $zoomin = new SWF::Button();
	my $zoominshape=&makeZoomin(0xdd, 0xdd, 0xdd, 0xff, 30, 30,1);
	my $zoominshape2=&makeZoomin(0xff, 0xcc, 0x33, 0xff, 30, 30,1);
	$zoomin->addShape($zoominshape, SWFBUTTON_UP|SWFBUTTON_HIT);
	$zoomin->addShape($zoominshape2, SWFBUTTON_OVER|SWFBUTTON_DOWN);
	$zoomin->addAction(new SWF::Action("
_root.viewport.view._xscale=_root.viewport.view._xscale*2;
_root.viewport.view._yscale=_root.viewport.view._yscale*2;
	"), SWFBUTTON_MOUSEUP);
	
	# zoom buttons
	my $zoomout = new SWF::Button();
	my $zoomoutshape=&makeZoomout(0xdd, 0xdd, 0xdd, 0xff, 30, 30, 1);
	my $zoomoutshape2=&makeZoomout(0xff, 0xcc, 0x33, 0xff, 30, 30, 1);
	$zoomout->addShape($zoomoutshape, SWFBUTTON_UP|SWFBUTTON_HIT);
	$zoomout->addShape($zoomoutshape2, SWFBUTTON_OVER|SWFBUTTON_DOWN);
	$zoomout->addAction(new SWF::Action("
_root.viewport.view._xscale=_root.viewport.view._xscale/2;
_root.viewport.view._yscale=_root.viewport.view._yscale/2;
	"), SWFBUTTON_MOUSEUP);	



	# put stop/pause/play/zoominout in 1 movieclip with 2 frames
	my $controls=new SWF::MovieClip();
	my $stop_i= $controls->add($stop);
	my $play_i= $controls->add($play);
	my $zoomin_i= $controls->add($zoomin);
	my $zoomout_i= $controls->add($zoomout);
	$play_i->move(35,0);
	$zoomin_i->move(70,0);
	$zoomout_i->move(105,0);
	$controls->add(new SWF::Action("stop();"));
	$controls->nextFrame(); # frame 1
	
	$controls->remove($play_i);
	my $pause_i=$controls->add($pause);
	$pause_i->move(35,0);
	$controls->add(new SWF::Action("stop();"));
	$controls->nextFrame(); # frame 2
	
	# statistic button
	my $mcstat=new SWF::MovieClip();

	my $bstat = new SWF::Button();
	$bstat->addShape($infoshape, SWFBUTTON_UP|SWFBUTTON_HIT);
	$bstat->addShape($infoshape2, SWFBUTTON_OVER|SWFBUTTON_DOWN);
	$bstat->addAction(new SWF::Action("
_root.infowindow._visible=1;
	"), SWFBUTTON_MOUSEUP);	
	
	my $bstat_i=$mcstat->add($bstat);
	my $tstat_i=$mcstat->add(&makeText("Statistic",14));
	$tstat_i->move(5,15);
	$mcstat->nextFrame();
	
	#help button
	my $mchelp=new SWF::MovieClip();

	my $bhelp = new SWF::Button();
	$bhelp->addShape($infoshape, SWFBUTTON_UP|SWFBUTTON_HIT);
	$bhelp->addShape($infoshape2, SWFBUTTON_OVER|SWFBUTTON_DOWN);
	$bhelp->addAction(new SWF::Action("_root.helpwindow._visible=1;"), SWFBUTTON_MOUSEUP);	
	
	my $bhelp_i=$mchelp->add($bhelp);
	my $thelp_i=$mchelp->add(&makeText("Help",14));
	$thelp_i->move(5,15);
  $mchelp->nextFrame();
	
	# autoupdate button
	my $mcAuto=new SWF::MovieClip();
	$mcAuto->add(new SWF::Action("stop();"));
	my $bAuto = new SWF::Button();
	$bAuto->addShape($infoshape, SWFBUTTON_UP|SWFBUTTON_HIT);
	$bAuto->addShape($infoshape2, SWFBUTTON_OVER|SWFBUTTON_DOWN);
	$bAuto->addAction(new SWF::Action("
_root.autoupdate=1; 
gotoandstop(2);
view=_root.viewport.view;
//restart timers if playing
if (view.isplaying == 1){
	for (var i=0; i<$nn; i++){
		if (view.nb[i]._visible == 1){
			view[i].nbrestart();
		}
		if (view.rt[i]._visible == 1){
			view[i].rtrestart();
		}
	}
}
else {
//update 1 time
for (var i=0; i<$nn; i++){
		if (view.nb[i]._visible == 1){
			view[i].nbupdate();
		}
		if (view.rt[i]._visible == 1){
			view[i].rtupdate();
		}
	}
}
gotoandstop(2);
"), SWFBUTTON_MOUSEUP);	
	
	my $bAuto_i=$mcAuto->add($bAuto);
	my $tAuto_i=$mcAuto->add(&makeText("Auto is off",12));
	$tAuto_i->move(3,15);
  $mcAuto->nextFrame;
	
	$bAuto = new SWF::Button;
	$bAuto->addShape($infoshape, SWFBUTTON_UP|SWFBUTTON_HIT);
	$bAuto->addShape($infoshape2, SWFBUTTON_OVER|SWFBUTTON_DOWN);
	$bAuto->addAction(new SWF::Action("
_root.autoupdate=0; 
gotoandstop(1);
"), SWFBUTTON_MOUSEUP);	
	
	$mcAuto->remove($bAuto_i);
	$mcAuto->remove($tAuto_i);
	$bAuto_i=$mcAuto->add($bAuto);
	$tAuto_i=$mcAuto->add(&makeText("Auto is on",12));
	$tAuto_i->move(4,15);
  $mcAuto->nextFrame;
	
	
	#controlbg
	my $cbg = new SWF::Shape();
	
	$cbg->setRightFill(0xee, 0xee, 0xee);
	$cbg->setLine(20, 0xcc, 0xcc, 0xcc);
	$cbg->drawLine($moviex-1, 0);
	$cbg->drawLine(0, 55);
	$cbg->drawLineTo(0, 55);
	$cbg->drawLineTo(0, 0);
	
	$cbg->setRightFill();
	$cbg->setLine(20, 0xcc, 0xcc, 0xcc);
	$cbg->movePenTo(3, 2);
	$cbg->drawLine(0, 30);
	$cbg->movePenTo(5, 2);
	$cbg->drawLine(0, 6);

	#slider
	my $slider = &makeSlider;
	
	my $controlbar = new SWF::MovieClip();
	
	$controlbar->add($cbg);
	#not working proper for now
	#my $slider_inst = $controlbar->add($slider);
	my $timeline_inst = $controlbar->add($timeline);
	my $tfields_inst = $controlbar->add($tfields);
	my $mcstat_inst = $controlbar->add($mcstat);
	my $mchelp_inst = $controlbar->add($mchelp);
	my $mcAuto_inst = $controlbar->add($mcAuto);
	my $controls_inst = $controlbar->add($controls);
	$controls_inst->setName('control'); #rename later to avoid developer irritation with 'controlbar'
	#$slider_inst->setName('slider');
	#$slider_inst->moveTo(10,10);
	$tfields_inst->moveTo(0,0);
	$timeline_inst->moveTo(10,40);
	$mcstat_inst->moveTo(340,10);
	$mchelp_inst->moveTo(480,10);
	$mcAuto_inst->moveTo(410,10);
	$controls_inst->moveTo(10,4);
	$controlbar->nextFrame; # finish the controlbar-object
	

	
	my $view = new SWF::MovieClip();
	$view->add(new SWF::Action("stop();"));
	
	# code for background image
	if (-e "$mapimage" && -r "$mapimage") {
		my $map =&makemap($mapimage);
		my $map_inst = $view->add($map);
		$map_inst->scale(1*$factor,1*$factor);
		# make it brighter so that it not irritates our eyes too much :-)
		# don't play with alpha here, rendering alpha eats your cpu-power..
		$map_inst->addColor(0xcc, 0xcc , 0xcc); #0-255,alpha optional
		# $map_inst->multColor(2.0, 2.0 ,2.0); #multColor between -6?.0 and 64.0!! ming should handled it nicer, but not done.
	}
	
	my $coord_inst = $view->add($coord);
	$coord_inst->moveTo(0,$scaledysize);
	
	# placeolders for neighbor and routelines
	my $nb= new SWF::MovieClip;
	$nb->nextFrame;
	my $nb_i=$view->add($nb);
	$nb_i->setName("nb");
	
	my $rt= new SWF::MovieClip;
	$rt->nextFrame;
	my $rt_i=$view->add($rt);
	$rt_i->setName("rt");

	my @nodes;
	my $nodeskeleton=&buildMobileNode();
	for (my $i=0;$i<$nn;$i++) {	
		$nodes[$i] = $view->add($nodeskeleton);
		$nodes[$i]->setName($i);
	}

	my $simtime=0.0;
	my $lastframe=0;
	my $z=0;
	
	open(TRACEFILE,"$main::tracefile") or &sendError("Couldn't open file $main::tracefile .\n");
	#full read into the prog. to speed up. If you have problems because your file is too big or you haven't enough RAM let them read line by line
	#my @trace=<TRACEFILE>;
	#close(TRACEFILE) or &sendError("Couldn't close file $tracefile .\n");
	
	my $row;
	my $readlines=0;
	while (defined($row=<TRACEFILE>))
	#foreach my $row (@trace)
	{	
		my $rest= $readlines%10000;
		if ($rest == 0) {
			printf( "%d \n", $readlines);
		}
		$readlines++;
		
		if($row =~ /^[srfd] / ) #send,recv,forw,drop
		{ 	
			my @line;
			@line = split(/ /,$row);
			#TODO: better detection of values in line needed. don't use index, make hash or something like that 
			if ($line[10] =~ /\d/) 
			{	
				$simtime=$line[2];
				my $frame=int($simtime*$framefreq);
				#fill empty timeslots			
				if ($frame ne $lastframe) {
					my $diff = $frame-$lastframe;
					while ($diff>0){
						$view->nextFrame(); 
						$diff--; 
						$z++; 
					}
				}
				
				my $x_=$line[10];
				my $y_=$line[12];
				#print(STDERR "x:".$x_." y:".$y_."\n");
				# comment: if we read impossible values ..
				#if  ($x_ < 0 or  $x_ > $xsize or $y_ < 0 or $y_ > $ysize) {
				#	
				#	$nodes[$line[4]]->moveTo(0,$scaledysize);
				#else {
					$nodes[$line[4]]->moveTo($x_*$factor,$scaledysize-$y_*$factor);
				#}
				$lastframe=$frame;
			}
			else {print STDERR $line[10]."\n";}	
		}
	}
	# when reading line by line, close here the file, if not comment out.
	close(TRACEFILE) or &sendError("Couldn't close file $main::tracefile .\n");
	
	print(STDERR "Last tracefile entry at ".$simtime."\nFrames:".($lastframe+1)." (".($z+1).")\n");
	$view->add(new SWF::Action("
this.stop();
this.isplaying=0;
_root.controlbar.control.gotoandstop(1);
"));
	$view->labelFrame("end");
	$view->nextFrame(); # finish the last frame of $view

	my $viewport = new SWF::MovieClip();
	my $view_inst = $viewport->add($view);
	$view_inst->move(10,60);
	$view_inst->setName('view');	
	$viewport->nextFrame(); #finish viewport
	
	my $viewport_inst = $movie->add($viewport);
	$viewport_inst->setName('viewport');
	
	my $controlbar_inst = $movie->add($controlbar);
	$controlbar_inst->setName('controlbar');
	
	#at top we set the small draggercontrol
	my $dragger =&dragger();
	
	my $dragger_inst = $movie->add($dragger);
	$dragger_inst->setName('dragger');
	$dragger_inst->move($moviex-70,80);

	my $infowindow=&makeStatWindow;
	#print STDERR "after makeStatWindow\n";
	my $infowindow_inst = $movie->add($infowindow);
	$infowindow_inst->setName('infowindow');
	$infowindow_inst->move($moviex/2-250,80);
	
	$movie->add(new SWF::Action("
infowindow._visible=0;
helpwindow._visible=0;	
"));

	my $helpwindow=&makeHelpWindow;
	#print STDERR "after makeHelpWindow\n";
	# get seqfault in ming0.2a here :-(
	my $helpwindow_inst = $movie->add($helpwindow);
	$helpwindow_inst->setName('helpwindow');
	$helpwindow_inst->move($moviex/2-200,100);

	$movie->nextFrame();
	print STDERR "after nextFrame\n";
	$movie->save("$main::tracefile.swf");
	print STDERR "after save\n";
}

=item sub makeStatWindow()

function to receive statististic data. Uses the package TraceStat (file TraceStat.pm)
and build show some of the calculated statistics. 

ToDo: Some Graphs can here be build very easy.

ToDo: An export of stats/graphs to postscript/PDF output for the webversion are imaginable.

=cut

sub makeStatWindow {
	
	# interface changed. now TraceStat is full objectoriented.
	# Further: If the stats as xmlfile still exist (tracefile.tr.xml),
	# we don't need to recalculate the stats and can use the ready xml-file. :-)
	my $stat;
#	if (-r "tracefile.tr.xml") {
#		# parse the xml file (use a xmlparser, XML::DOM or sth. like that)
#		$stat={};
#		$stat->{AGT_CBR} ={s=>'bla', f=>'bla', r=>'bla', d=>'bla', u=>'bla'};
#	}
#	else{ 
		$stat = new TraceStat;
		$stat->makeStat($main::tracefile);
#	}
	my $x=600;my $y=400;
	my $mc = new SWF::MovieClip();
	my $bg=&makerect(0xee, 0xee, 0xee, 0xcc, $x, $y, 1);
	$mc->add($bg);
	my $dragbar=&makedragbar($x,"Statistic",$fontfile);
	my $dragbar_i=$mc->add($dragbar);

	
	my $SIM= new SWF::MovieClip();
		my $bSIM = new SWF::Button();
		$bSIM->addShape($blshape, SWFBUTTON_UP|SWFBUTTON_HIT);
		$bSIM->addShape($blshape2, SWFBUTTON_OVER|SWFBUTTON_DOWN);
		$a=new SWF::Action("_root.infowindow.statview.gotoandstop(1);");
		$bSIM->addAction($a, SWFBUTTON_MOUSEUP);
		$SIM->add($bSIM);
		my $tSIM=&makeText("Overview",14);
		my $tSIM_i=$SIM->add($tSIM);
		$tSIM_i->move(10,15);
	$SIM->nextFrame();
		
	my $AGT= new SWF::MovieClip();
		my $bAGT = new SWF::Button();
		$bAGT->addShape($bshape, SWFBUTTON_UP|SWFBUTTON_HIT);
		$bAGT->addShape($bshape2, SWFBUTTON_OVER|SWFBUTTON_DOWN);
		$a=new SWF::Action("_root.infowindow.statview.gotoandstop(2);");
		$bAGT->addAction($a, SWFBUTTON_MOUSEUP);
		$AGT->add($bAGT);
		my $tAGT=&makeText("AGT",14);
		my $tAGT_i=$AGT->add($tAGT);
		$tAGT_i->move(10,15);
	$AGT->nextFrame();
	
	my $RTR= new SWF::MovieClip();
		my $bRTR = new SWF::Button();
		$bRTR->addShape($bshape, SWFBUTTON_UP|SWFBUTTON_HIT);
		$bRTR->addShape($bshape2, SWFBUTTON_OVER|SWFBUTTON_DOWN);
		$a=new SWF::Action("_root.infowindow.statview.gotoandstop(3);");
		$bRTR->addAction($a, SWFBUTTON_MOUSEUP);
		$RTR->add($bRTR);
		my $tRTR=&makeText("RTR",14);
		my $tRTR_i=$RTR->add($tRTR);
		$tRTR_i->move(10,15);
	$RTR->nextFrame();
	
	my $MAC= new SWF::MovieClip();
		my $bMAC = new SWF::Button();
		$bMAC->addShape($bshape, SWFBUTTON_UP|SWFBUTTON_HIT);
		$bMAC->addShape($bshape2, SWFBUTTON_OVER|SWFBUTTON_DOWN);
		$a=new SWF::Action("_root.infowindow.statview.gotoandstop(4);");
		$bMAC->addAction($a, SWFBUTTON_MOUSEUP);
		$MAC->add($bMAC);
		my $tMAC=&makeText("MAC",14);
		my $tMAC_i=$MAC->add($tMAC);
		$tMAC_i->move(10,15);
	$MAC->nextFrame();
		
	my $IFQ= new SWF::MovieClip();
		my $bIFQ = new SWF::Button();
		$bIFQ->addShape($bshape, SWFBUTTON_UP|SWFBUTTON_HIT);
		$bIFQ->addShape($bshape2, SWFBUTTON_OVER|SWFBUTTON_DOWN);
		$a=new SWF::Action("_root.infowindow.statview.gotoandstop(5);");
		$bIFQ->addAction($a, SWFBUTTON_MOUSEUP);
		$IFQ->add($bIFQ);
		my $tIFQ=&makeText("IFQ",14);
		my $tIFQ_i=$IFQ->add($tIFQ);
		$tIFQ_i->move(10,15);
	$IFQ->nextFrame();
	
	my $tabshape=&makerect(0xee, 0xee, 0xee, 0xFF, $x-40, $y-80, 1);
	
	# Overview Frame
	my $tab1= new SWF::MovieClip();
	$tab1->add($tabshape);
	{
		my $title=&makeText("Simulation Overview",16);
		my $title_i=$tab1->add($title);	
		$title_i->move($x/2-100,20);
	
		my $t0=&makeText("Nodes: $nn",14);
		my $t1=&makeText("Propagation: $propagation",14);
		my $t2=&makeText("Adhoc Routing Protocol: $routingproto",14);
		my $t3=&makeText("Antenna: $antenna",14);
		#my $t5=&makeText("Max. Speed: $maxspeed",14);
		
		my $i=2;
		my $t0_i=$tab1->add($t0); $t0_i->move(40,$i*20);$i++;
		my $t1_i=$tab1->add($t1); $t1_i->move(40,$i*20);$i++;
		my $t2_i=$tab1->add($t2); $t2_i->move(40,$i*20);$i++;
		my $t3_i=$tab1->add($t3); $t3_i->move(40,$i*20);
		$tab1->nextFrame;
	}
	# AGT Frame
	my $tab2= new SWF::MovieClip();
	$tab2->add($tabshape);
	{
		my $title=&makeText("Agent/Application Tracelevel",16);
		my $title_i=$tab2->add($title);	
		$title_i->move($x/2-150,20);
	}	
	my $th1=&makeText("send",14);
	my $th2=&makeText("recv",14);
	my $th3=&makeText("forward",14);
	my $th4=&makeText("drop",14);
	my $th5=&makeText("unknown",14);
	
	my $t1t=&makeText("UDP/CBR packets",14);
	my $t1s=&makeText($stat->{AGT_CBR}{s},14);
	my $t1r=&makeText($stat->{AGT_CBR}{r},14);
	my $t1f=&makeText($stat->{AGT_CBR}{f},14);
	my $t1d=&makeText($stat->{AGT_CBR}{d},14);
	my $t1u=&makeText($stat->{AGT_CBR}{u},14);
	
	my $t2t=&makeText("UDP/CBR bytes",14);
	my $t2s=&makeText($stat->{AGT_CBR}{sB},14);
	my $t2r=&makeText($stat->{AGT_CBR}{rB},14);
	my $t2f=&makeText($stat->{AGT_CBR}{fB},14);
	my $t2d=&makeText($stat->{AGT_CBR}{dB},14);
	my $t2u=&makeText($stat->{AGT_CBR}{uB},14);
	
	my $t3t=&makeText("TCP packets",14);
	my $t3s=&makeText($stat->{AGT_TCP}{s},14);
	my $t3r=&makeText($stat->{AGT_TCP}{r},14);
	my $t3f=&makeText($stat->{AGT_TCP}{f},14);
	my $t3d=&makeText($stat->{AGT_TCP}{d},14);
	my $t3u=&makeText($stat->{AGT_TCP}{u},14);


	my $t4t=&makeText("TCP bytes",14);
	my $t4s=&makeText($stat->{AGT_TCP}{sB},14);
	my $t4r=&makeText($stat->{AGT_TCP}{rB},14);
	my $t4f=&makeText($stat->{AGT_TCP}{fB},14);
	my $t4d=&makeText($stat->{AGT_TCP}{dB},14);
	my $t4u=&makeText($stat->{AGT_TCP}{uB},14);
	
	my $agtdelayt=&makeText("end2end delay\n",14);
	my $agtdelaytf = new SWF::TextField(SWFTEXTFIELD_DRAWBOX|SWFTEXTFIELD_HASLENGTH|SWFTEXTFIELD_NOEDIT|SWFTEXTFIELD_NOSELECT);
        $agtdelaytf->setBounds(60, 14);
        $agtdelaytf->setFont($font); 
        $agtdelaytf->setHeight(14);
        $agtdelaytf->setColor(0x00, 0x00, 0x00, 0xff);
	$agtdelaytf->setAlignment(SWFTEXTFIELD_ALIGN_RIGHT);
	$agtdelaytf->addString($stat->{AGT_end_to_end_delay});
	my $agtdelaytsec=&makeText("s\n",14);
	
	#placing into tab2 (AGT)
	{ 
		my $i=2; my $j=2;
		my $th1_i=$tab2->add($th1); $th1_i->move(80*$i,20*$j); $i++;
		my $th2_i=$tab2->add($th2); $th2_i->move(80*$i,20*$j); $i++;
		my $th3_i=$tab2->add($th3); $th3_i->move(80*$i,20*$j); $i++;
		my $th4_i=$tab2->add($th4); $th4_i->move(80*$i,20*$j); 
		my $th5_i=$tab2->add($th5); $th5_i->move(80*$i+60,20*$j); 
	
		$i=1; $j++;
		my $t1t_i=$tab2->add($t1t); $t1t_i->move(10,    20*$j); $i++;
		my $t1s_i=$tab2->add($t1s); $t1s_i->move(80*$i,20*$j); $i++;
		my $t1r_i=$tab2->add($t1r); $t1r_i->move(80*$i,20*$j); $i++;
		my $t1f_i=$tab2->add($t1f); $t1f_i->move(80*$i,20*$j); $i++;
		my $t1d_i=$tab2->add($t1d); $t1d_i->move(80*$i,20*$j); 
		my $t1u_i=$tab2->add($t1u); $t1u_i->move(80*$i+60,20*$j);
	
		$i=1;$j++;
		my $t2t_i=$tab2->add($t2t); $t2t_i->move(10,    20*$j); $i++;
		my $t2s_i=$tab2->add($t2s); $t2s_i->move(80*$i,20*$j); $i++;
		my $t2r_i=$tab2->add($t2r); $t2r_i->move(80*$i,20*$j); $i++;
		my $t2f_i=$tab2->add($t2f); $t2f_i->move(80*$i,20*$j); $i++;
		my $t2d_i=$tab2->add($t2d); $t2d_i->move(80*$i,20*$j); 
		my $t2u_i=$tab2->add($t2u); $t2u_i->move(80*$i+60,20*$j); 
	
		$i=1; $j=$j+2;
		my $t3t_i=$tab2->add($t3t); $t3t_i->move(10,    20*$j); $i++;
		my $t3s_i=$tab2->add($t3s); $t3s_i->move(80*$i,20*$j); $i++;
		my $t3r_i=$tab2->add($t3r); $t3r_i->move(80*$i,20*$j); $i++;
		my $t3f_i=$tab2->add($t3f); $t3f_i->move(80*$i,20*$j); $i++;
		my $t3d_i=$tab2->add($t3d); $t3d_i->move(80*$i,20*$j); 
		my $t3u_i=$tab2->add($t3u); $t3u_i->move(80*$i+60,20*$j);
	
		$i=1;$j++;
		my $t4t_i=$tab2->add($t4t); $t4t_i->move(10,    20*$j); $i++;
		my $t4s_i=$tab2->add($t4s); $t4s_i->move(80*$i,20*$j); $i++;
		my $t4r_i=$tab2->add($t4r); $t4r_i->move(80*$i,20*$j); $i++;
		my $t4f_i=$tab2->add($t4f); $t4f_i->move(80*$i,20*$j); $i++;
		my $t4d_i=$tab2->add($t4d); $t4d_i->move(80*$i,20*$j);
		my $t4u_i=$tab2->add($t4u); $t4u_i->move(80*$i+60,20*$j);
	
		$j++;$j++;
		my $agtdelayt_i    = $tab2->add($agtdelayt);  $agtdelayt_i->move(30,20*$j);
		my $agtdelaytf_i   = $tab2->add($agtdelaytf); $agtdelaytf_i->move(70*2,20*$j-14);
		my $agtdelaytsec_i = $tab2->add($agtdelaytsec);  $agtdelaytsec_i->move(210,20*$j);
	
		$tab2->nextFrame;
	}

	my $tab3= new SWF::MovieClip();
	{
		$tab3->add($tabshape);
		
		my $title=&makeText("Route Tracelevel",16);
		my $title_i=$tab3->add($title);	
		$title_i->move($x/2-100,20);
		my $i=2; my $j=2;
		my $th1_i=$tab3->add($th1); $th1_i->move(80*$i,20*$j); $i++;
		my $th2_i=$tab3->add($th2); $th2_i->move(80*$i,20*$j); $i++;
		my $th3_i=$tab3->add($th3); $th3_i->move(80*$i,20*$j); $i++;
		my $th4_i=$tab3->add($th4); $th4_i->move(80*$i,20*$j); 
		my $th5_i=$tab3->add($th5); $th5_i->move(80*$i+60,20*$j);
		print "debug: $routingproto\n";
		if ($routingproto =~ /AODV/) {
			my $t1t=&makeText("AODV RREQ",14);	
			my $t1s=&makeText($stat->{RTR_AODVRREQ}{s},14);
			my $t1r=&makeText($stat->{RTR_AODVRREQ}{r},14);
			my $t1f=&makeText($stat->{RTR_AODVRREQ}{f},14);
			my $t1d=&makeText($stat->{RTR_AODVRREQ}{d},14);
			my $t1u=&makeText($stat->{RTR_AODVRREQ}{u},14);
			
			my $t2t=&makeText("AODV RREP",14);	
			my $t2s=&makeText($stat->{RTR_AODVRREP}{s},14);
			my $t2r=&makeText($stat->{RTR_AODVRREP}{r},14);
			my $t2f=&makeText($stat->{RTR_AODVRREP}{f},14);
			my $t2d=&makeText($stat->{RTR_AODVRREP}{d},14);
			my $t2u=&makeText($stat->{RTR_AODVRREP}{u},14);
			
			my $t3t=&makeText("AODV ERROR",14);	
			my $t3s=&makeText($stat->{RTR_AODVERROR}{s},14);
			my $t3r=&makeText($stat->{RTR_AODVERROR}{r},14);
			my $t3f=&makeText($stat->{RTR_AODVERROR}{f},14);
			my $t3d=&makeText($stat->{RTR_AODVERROR}{d},14);
			my $t3u=&makeText($stat->{RTR_AODVERROR}{u},14);
			
			my $t4t=&makeText("AODV HELLO",14);	
			my $t4s=&makeText($stat->{RTR_AODVHELLO}{s},14);
			my $t4r=&makeText($stat->{RTR_AODVHELLO}{r},14);
			my $t4f=&makeText($stat->{RTR_AODVHELLO}{f},14);
			my $t4d=&makeText($stat->{RTR_AODVHELLO}{d},14);
			my $t4u=&makeText($stat->{RTR_AODVHELLO}{u},14);
			
			my $t6t=&makeText("UDP/CBR",14);	
			my $t6s=&makeText($stat->{RTR_CBR}{s},14);
			my $t6r=&makeText($stat->{RTR_CBR}{r},14);
			my $t6f=&makeText($stat->{RTR_CBR}{f},14);
			my $t6d=&makeText($stat->{RTR_CBR}{d},14);
			my $t6u=&makeText($stat->{RTR_CBR}{u},14);
			
			my $t7t=&makeText("TCP",14);	
			my $t7s=&makeText($stat->{RTR_TCP}{s},14);
			my $t7r=&makeText($stat->{RTR_TCP}{r},14);
			my $t7f=&makeText($stat->{RTR_TCP}{f},14);
			my $t7d=&makeText($stat->{RTR_TCP}{d},14);
			my $t7u=&makeText($stat->{RTR_TCP}{u},14);
			
			# not implemented in my ns
			#my $t5t=&makeText("AODV ACK",14);	
			#my $t5s=&makeText($stat->{RTR_AODVACK}{s},14);
			#my $t5r=&makeText($stat->{RTR_AODVACK}{r},14);
			#my $t5f=&makeText($stat->{RTR_AODVACK}{f},14);
			#my $t5d=&makeText($stat->{RTR_AODVACK}{d},14);
			#my $t5u=&makeText($stat->{RTR_AODVACK}{u},14);
			
			$i=1; $j++;
			my $t1t_i=$tab3->add($t1t); $t1t_i->move( 10  ,20*$j); $i++;
			my $t1s_i=$tab3->add($t1s); $t1s_i->move(80*$i,20*$j); $i++;
			my $t1r_i=$tab3->add($t1r); $t1r_i->move(80*$i,20*$j); $i++;
			my $t1f_i=$tab3->add($t1f); $t1f_i->move(80*$i,20*$j); $i++;
			my $t1d_i=$tab3->add($t1d); $t1d_i->move(80*$i,20*$j); 
			my $t1u_i=$tab3->add($t1u); $t1u_i->move(80*$i+60,20*$j);
		
			$i=1;$j++;
			my $t2t_i=$tab3->add($t2t); $t2t_i->move( 10  ,20*$j); $i++;
			my $t2s_i=$tab3->add($t2s); $t2s_i->move(80*$i,20*$j); $i++;
			my $t2r_i=$tab3->add($t2r); $t2r_i->move(80*$i,20*$j); $i++;
			my $t2f_i=$tab3->add($t2f); $t2f_i->move(80*$i,20*$j); $i++;
			my $t2d_i=$tab3->add($t2d); $t2d_i->move(80*$i,20*$j); 
			my $t2u_i=$tab3->add($t2u); $t2u_i->move(80*$i+60,20*$j); 
		
			$i=1;$j++;
			my $t3t_i=$tab3->add($t3t); $t3t_i->move( 10  ,20*$j); $i++;
			my $t3s_i=$tab3->add($t3s); $t3s_i->move(80*$i,20*$j); $i++;
			my $t3r_i=$tab3->add($t3r); $t3r_i->move(80*$i,20*$j); $i++;
			my $t3f_i=$tab3->add($t3f); $t3f_i->move(80*$i,20*$j); $i++;
			my $t3d_i=$tab3->add($t3d); $t3d_i->move(80*$i,20*$j);
			my $t3u_i=$tab3->add($t3u); $t3u_i->move(80*$i+60,20*$j); 
		
			$i=1;$j++;
			my $t4t_i=$tab3->add($t4t); $t4t_i->move( 10  ,20*$j); $i++;
			my $t4s_i=$tab3->add($t4s); $t4s_i->move(80*$i,20*$j); $i++;
			my $t4r_i=$tab3->add($t4r); $t4r_i->move(80*$i,20*$j); $i++;
			my $t4f_i=$tab3->add($t4f); $t4f_i->move(80*$i,20*$j); $i++;
			my $t4d_i=$tab3->add($t4d); $t4d_i->move(80*$i,20*$j);
			my $t4u_i=$tab3->add($t4u); $t4u_i->move(80*$i+60,20*$j);
			
			$i=1;$j++;
			my $t6t_i=$tab3->add($t6t); $t6t_i->move( 10  ,20*$j); $i++;
			my $t6s_i=$tab3->add($t6s); $t6s_i->move(80*$i,20*$j); $i++;
			my $t6r_i=$tab3->add($t6r); $t6r_i->move(80*$i,20*$j); $i++;
			my $t6f_i=$tab3->add($t6f); $t6f_i->move(80*$i,20*$j); $i++;
			my $t6d_i=$tab3->add($t6d); $t6d_i->move(80*$i,20*$j);
			my $t6u_i=$tab3->add($t6u); $t6u_i->move(80*$i+60,20*$j); 
		
			$i=1;$j++;
			my $t7t_i=$tab3->add($t7t); $t7t_i->move( 10  ,20*$j); $i++;
			my $t7s_i=$tab3->add($t7s); $t7s_i->move(80*$i,20*$j); $i++;
			my $t7r_i=$tab3->add($t7r); $t7r_i->move(80*$i,20*$j); $i++;
			my $t7f_i=$tab3->add($t7f); $t7f_i->move(80*$i,20*$j); $i++;
			my $t7d_i=$tab3->add($t7d); $t7d_i->move(80*$i,20*$j);
			my $t7u_i=$tab3->add($t7u); $t7u_i->move(80*$i+60,20*$j);
		}
		
		my $t6t=&makeText("sum RTR Packets",14);
		my $t6s=&makeText($stat->{sumRTR}{s},14);
		my $t6r=&makeText($stat->{sumRTR}{r},14);
		my $t6f=&makeText($stat->{sumRTR}{f},14);
		my $t6d=&makeText($stat->{sumRTR}{d},14);
		my $t6u=&makeText($stat->{sumRTR}{u},14);

		$i=1; $j++;$j++;
		my $t6t_i=$tab3->add($t6t); $t6t_i->move(  10 ,20*$j); $i++;
		my $t6s_i=$tab3->add($t6s); $t6s_i->move(80*$i,20*$j); $i++;
		my $t6r_i=$tab3->add($t6r); $t6r_i->move(80*$i,20*$j); $i++;
		my $t6f_i=$tab3->add($t6f); $t6f_i->move(80*$i,20*$j); $i++;
		my $t6d_i=$tab3->add($t6d); $t6d_i->move(80*$i,20*$j); 
		my $t6u_i=$tab3->add($t6u); $t6u_i->move(80*$i+60,20*$j);
		
		my $t7t=&makeText("sum RTR Bytes",14);
		my $t7s=&makeText($stat->{sumRTR}{sB},14);
		my $t7r=&makeText($stat->{sumRTR}{sB},14);
		my $t7f=&makeText($stat->{sumRTR}{fB},14);
		my $t7d=&makeText($stat->{sumRTR}{dB},14);
		my $t7u=&makeText($stat->{sumRTR}{uB},14);

		$i=1; $j++;
		my $t7t_i=$tab3->add($t7t); $t7t_i->move(  10 ,20*$j); $i++;
		my $t7s_i=$tab3->add($t7s); $t7s_i->move(80*$i,20*$j); $i++;
		my $t7r_i=$tab3->add($t7r); $t7r_i->move(80*$i,20*$j); $i++;
		my $t7f_i=$tab3->add($t7f); $t7f_i->move(80*$i,20*$j); $i++;
		my $t7d_i=$tab3->add($t7d); $t7d_i->move(80*$i,20*$j); 
		my $t7u_i=$tab3->add($t7u); $t7u_i->move(80*$i+60,20*$j);

	}
	$tab3->nextFrame;
	

	my $tab4= new SWF::MovieClip();
	$tab4->add($tabshape);
	{
		my $title=&makeText("MAC Tracelevel",16);
		my $title_i=$tab4->add($title);	
		$title_i->move($x/2-100,20);
	}
	{	
		my $i=2; my $j=2;
		my $th1_i=$tab4->add($th1); $th1_i->move(80*$i,20*$j); $i++;
		my $th2_i=$tab4->add($th2); $th2_i->move(80*$i,20*$j); $i++;
		my $th3_i=$tab4->add($th3); $th3_i->move(80*$i,20*$j); $i++;
		my $th4_i=$tab4->add($th4); $th4_i->move(80*$i,20*$j); 
		my $th5_i=$tab4->add($th5); $th5_i->move(80*$i+60,20*$j);
		
		my $t6t=&makeText("sum MAC Packets",14);
		my $t6s=&makeText($stat->{sumMAC}{s},14);
		my $t6r=&makeText($stat->{sumMAC}{r},14);
		my $t6f=&makeText($stat->{sumMAC}{f},14);
		my $t6d=&makeText($stat->{sumMAC}{d},14);
		my $t6u=&makeText($stat->{sumMAC}{u},14);

		$i=1; $j++;$j++;
		my $t6t_i=$tab4->add($t6t); $t6t_i->move(  10 ,20*$j); $i++;
		my $t6s_i=$tab4->add($t6s); $t6s_i->move(80*$i,20*$j); $i++;
		my $t6r_i=$tab4->add($t6r); $t6r_i->move(80*$i,20*$j); $i++;
		my $t6f_i=$tab4->add($t6f); $t6f_i->move(80*$i,20*$j); $i++;
		my $t6d_i=$tab4->add($t6d); $t6d_i->move(80*$i,20*$j); 
		my $t6u_i=$tab4->add($t6u); $t6u_i->move(80*$i+60,20*$j);
		
		my $t7t=&makeText("sum MAC Bytes",14);
		my $t7s=&makeText($stat->{sumMAC}{sB},14);
		my $t7r=&makeText($stat->{sumMAC}{sB},14);
		my $t7f=&makeText($stat->{sumMAC}{fB},14);
		my $t7d=&makeText($stat->{sumMAC}{dB},14);
		my $t7u=&makeText($stat->{sumMAC}{uB},14);

		$i=1; $j++;
		my $t7t_i=$tab4->add($t7t); $t7t_i->move(  10 ,20*$j); $i++;
		my $t7s_i=$tab4->add($t7s); $t7s_i->move(80*$i,20*$j); $i++;
		my $t7r_i=$tab4->add($t7r); $t7r_i->move(80*$i,20*$j); $i++;
		my $t7f_i=$tab4->add($t7f); $t7f_i->move(80*$i,20*$j); $i++;
		my $t7d_i=$tab4->add($t7d); $t7d_i->move(80*$i,20*$j); 
		my $t7u_i=$tab4->add($t7u); $t7u_i->move(80*$i+60,20*$j);
	}
	$tab4->nextFrame;
	
	my $tab5= new SWF::MovieClip();
	$tab5->add($tabshape);
	{
		my $title=&makeText("IFQ Tracelevel",16);
		my $title_i=$tab5->add($title);	
		$title_i->move($x/2-100,20);
	}
	{	
		my $i=2; my $j=2;
		my $th1_i=$tab4->add($th1); $th1_i->move(80*$i,20*$j); $i++;
		my $th2_i=$tab4->add($th2); $th2_i->move(80*$i,20*$j); $i++;
		my $th3_i=$tab4->add($th3); $th3_i->move(80*$i,20*$j); $i++;
		my $th4_i=$tab4->add($th4); $th4_i->move(80*$i,20*$j); 
		my $th5_i=$tab4->add($th5); $th5_i->move(80*$i+60,20*$j);
		
		my $t6t=&makeText("sum IFQ Packets",14);
		my $t6s=&makeText($stat->{IFQ}{s},14);
		my $t6r=&makeText($stat->{IFQ}{r},14);
		my $t6f=&makeText($stat->{IFQ}{f},14);
		my $t6d=&makeText($stat->{IFQ}{d},14);
		my $t6u=&makeText($stat->{IFQ}{u},14);

		$i=1; $j++;$j++;
		my $t6t_i=$tab4->add($t6t); $t6t_i->move(  10 ,20*$j); $i++;
		my $t6s_i=$tab4->add($t6s); $t6s_i->move(80*$i,20*$j); $i++;
		my $t6r_i=$tab4->add($t6r); $t6r_i->move(80*$i,20*$j); $i++;
		my $t6f_i=$tab4->add($t6f); $t6f_i->move(80*$i,20*$j); $i++;
		my $t6d_i=$tab4->add($t6d); $t6d_i->move(80*$i,20*$j); 
		my $t6u_i=$tab4->add($t6u); $t6u_i->move(80*$i+60,20*$j);
	}
	$tab5->nextFrame;

# bis =cut auskommentiert, entspricht /* bla */
#=for comment
#=cut
	
	##############################
	my $tabs= new SWF::MovieClip();
	$tabs->add(new SWF::Action("stop();"));
	my $tab1_i = $tabs->add($tab1); $tab1_i->move(0,0);
	$tabs->nextFrame;
	
	$tabs->remove($tab1_i);	
	my $tab2_i = $tabs->add($tab2);
	$tabs->nextFrame;
	
	$tabs->remove($tab2_i);
	my $tab3_i = $tabs->add($tab3);
	$tabs->nextFrame;
	$tabs->remove($tab3_i);
	my $tab4_i = $tabs->add($tab4);
	$tabs->nextFrame;
	$tabs->remove($tab4_i);
	my $tab5_i = $tabs->add($tab5);
	$tabs->nextFrame;



	print STDERR "after tab\n";
	my $tabs_i=$mc->add($tabs); $tabs_i->move(20,40);
	$tabs_i->setName("statview");
	
	# add our stuff to the infowindowmovieclip
	my $SIM_i=$mc->add($SIM); $SIM_i->move(70,20);
	my $AGT_i=$mc->add($AGT); $AGT_i->move(150,20);
	my $RTR_i=$mc->add($RTR); $RTR_i->move(200,20);
	my $MAC_i=$mc->add($MAC); $MAC_i->move(250,20);	
	
			
	my $ok=new SWF::MovieClip();
	#we reuse shapes
	my $b = new SWF::Button();
	$b->addShape($infoshape, SWFBUTTON_UP|SWFBUTTON_HIT);
	$b->addShape($infoshape2, SWFBUTTON_OVER|SWFBUTTON_DOWN);
	$b->addAction(new SWF::Action("
_root.infowindow._visible=0;
	"), SWFBUTTON_MOUSEUP);
	my $b_i=$ok->add($b);
	
	my $oktext=&makeText("OK",14);

	my $oktext_i=$ok->add($oktext);
	$oktext_i->move(20,15);
	$ok->nextFrame(); #finish $ok
	
	my $ok_i=$mc->add($ok);
	$ok_i->move($x/2-30,$y-30);
	
	
	#my $aodvbars = new SWF::Shape();
	# XXX more objectoriented design needed!!!
	#print STDERR "$stat->AGT_CBR{s}";
	
	print STDERR "AGT CBRsend: $stat->{AGT_CBR}{s}\n";
	
	$mc->nextFrame();
	return $mc;
}

=item sub makeHelpWindow()

function to build the helpdialog

=cut

sub makeHelpWindow {
	
	my $x=400; my $y=400;
	my $mc = new SWF::MovieClip();
	my $bg=&makerect(0xee, 0xee, 0xee, 0xcc, $x, $y, 1);
	$mc->add($bg);
	my $dragbar=&makedragbar($x,"Help",$fontfile);
	my $dragbar_i=$mc->add($dragbar);

	my $title=&makeText("",16);
		
	my $author= new SWF::MovieClip();
		my $bauthor = new SWF::Button();
		$bauthor->addShape($blshape, SWFBUTTON_UP|SWFBUTTON_HIT);
		$bauthor->addShape($blshape2, SWFBUTTON_OVER|SWFBUTTON_DOWN);
		$a=new SWF::Action("gotoandstop('author');");
		$bauthor->addAction($a, SWFBUTTON_MOUSEUP);
		$author->add($bauthor);
		my $tauthor=&makeText("Author",14);
		my $tauthor_i=$author->add($tauthor);
		$tauthor_i->move(10,15);
	$author->nextFrame();
	
	
	my $text=new SWF::TextField(SWFTEXTFIELD_NOSELECT|SWFTEXTFIELD_MULTILINE|SWFTEXTFIELD_WORDWRAP);
	$text->setBounds(350,350);
	$text->setFont($font); 
	$text->setHeight(14);
	$text->addString("You can click on the nodes to get more information about them. 
You can also use <tab> and <enter> to navigate. 

The nodemenus provide information about queue, latest routingtable of the node (button RT), latest neigbortable (button NT), and samples of measured signals of other nodes(the numbered buttons).

The queue- and samplediagrams are precalculated SWF-files by traceview and will be loaded on demand from the webserver or directory.

The routingtables and neighbortable are loaded on demand as XML-files from the webserver calling perlscript gettable.pl with parameters of time, simulation, node etc.
	");
	$text->setAlignment(SWFTEXTFIELD_ALIGN_LEFT);

	
	my $title_i=$mc->add($title);
	$title_i->move(30,30);
	my $text_i=$mc->add($text);
	$text_i->move(30,40);
	
	my $ok=new SWF::MovieClip();
	#we reuse shapes
	my $b = new SWF::Button();
	$b->addShape($infoshape, SWFBUTTON_UP|SWFBUTTON_HIT);
	$b->addShape($infoshape2, SWFBUTTON_OVER|SWFBUTTON_DOWN);
	$b->addAction(new SWF::Action("_parent._visible=0;"), SWFBUTTON_MOUSEUP);
	my $b_i=$ok->add($b);
	
	
	my $oktext=&makeText("OK",14);

	my $oktext_i=$ok->add($oktext);
	$oktext_i->move(20,15);
	$ok->nextFrame(); #finish $ok
	
	my $ok_i=$mc->add($ok);
	$ok_i->move($x/2-30,$y-30);
	$mc->nextFrame();
	return $mc;
}


=item sub makePacketFlows()

TODO: analyze the tracefile, pick up packets and trace its flow through the network (send,forward,receive,drop)

TODO: anim them, make packets clickable to view informations of the packet/packetflow (packetsize, routing overhead

TODO: Which strategy? 
	One separate swf-file for every packet?
	One separate swf-file for mobile node?
	One separate swf-file for every application in a mobile node? <- can we trace this? 

TODO: 
	statistic of simulation (send, recv, forw, drop, endtoend-communicatin/quality)
	statistics of different packettypes (UDP/CBR, TCP, AODV-REQUEST/HELLO/REPLY/ERROR)

=cut

sub makePacketFlows {
#Todo:Take Ids of packets/sender/receiver
#How to anim flows (Are "flows" packets that groups to one TrafficAgent(tcp,cbr)??)
#e.g. how i can detect analyze 2 different cbrstreams between nodeX and nodeY??

# 1 swfmovie for every packet? So I don't run into trouble, but ..

  #1. take a packetID starting with 0 and then crawl through the tracefile and search for this packet?  (-Ii integer)  
  #         $packetID =  /(\-Ii\s)(\d+)/$1/;
  #2. find send, recv, drop, forward  and take (position)information from this line
  
  #sendanim
  #recvanim
  #forwardanim
  #lineanim
   #
  #dropanim
}


=item sub buildMobileNode()

This part of this program constructs the skeleton and the controls of a mobile node. 

You can click on every node in the simulation area and have then access to the interface queue, 
measured signals of neighbors and other stuff.

The graphs will be loaded on demand, so we keep the mainflashmovie slim. If a graph of a neighbor will not popup,
then this node never got a signal from this neighbor and so this file not exist. but flash tolerates this(no error) :-)
	  
structure of a mobilenodemovieclip:
 frame1:
	movieclip
	  |-actionsscript(stop) 
	  |-nodebutton
	  |-textField
	  
 frame2:movieclip
 	  |-menushape
	  |-buttonclose
	  |-buttonqueue
		|-buttonrtable
		|-buttonntable
	  |-textfieldID
	  
	  |-buttonsamples0
	  |-testsamples0
	  ..
	  |-buttonsampleslastnode
	  |-testsampleslastnode
	  |-movieclipempty (name 'empty')

=cut
 
sub buildMobileNode {
 	my $shapeNode = &makeCenterrect(0xff, 0x66, 0x66, 8,8);
	my $shapeNode2 = &makeCenterrect(0xff, 0x99, 0x66, 10,10);
	
	#textfield for id
	my $textField = new SWF::TextField(SWFTEXTFIELD_HASLENGTH|SWFTEXTFIELD_NOEDIT|SWFTEXTFIELD_NOSELECT);
	$textField->setBounds(20, 14);
	$textField->setFont($font); 
	$textField->setHeight(12);
	$textField->setColor(0x00, 0x00, 0x00, 0xff);
	
	#$textField->setLength(5);
	#$textField->align(SWFTEXTFIELD_ALIGN_CENTER);
	$textField->setName('_name');

	# Mobile Node openMenu
	my $nodebutton = new SWF::Button();
	$nodebutton->addShape($shapeNode, SWFBUTTON_UP);
	$nodebutton->addShape($shapeNode2, SWFBUTTON_DOWN|SWFBUTTON_OVER|SWFBUTTON_HIT);
	$nodebutton->addAction(new SWF::Action("gotoandstop(2);"), SWFBUTTON_MOUSEUP);

	# Mobile Node closeMenu
	my $btn2 = new SWF::Button();
	my $closeme = &makeClose(0xff, 0xcc, 0x66, 0xff, 10,10,1);
	my $closeme2 = &makeClose(0xff, 0xff, 0xff, 0xff, 10,10,1);
	$btn2->addShape($closeme, SWFBUTTON_UP|SWFBUTTON_HIT);
	$btn2->addShape($closeme2, SWFBUTTON_DOWN|SWFBUTTON_OVER);
	$btn2->addAction(new SWF::Action("gotoandstop(1);"), SWFBUTTON_MOUSEUP);
	
	# Mobile Node queue/samples placeholder
	my $empty = new SWF::MovieClip();  # 1 frame
	$empty->nextFrame();  # frame 1 ok	

	# Mobile Node showQueue button
	my $btn_queue = new SWF::Button();	
	my $qshape = &makerect(0xff, 0xcc, 0x66, 0xff, 40,12,1);
	my $qshape2 = &makerect(0xff, 0xff, 0xff, 0xff, 40,12,1);
	$btn_queue->addShape($qshape, SWFBUTTON_UP|SWFBUTTON_HIT);
	$btn_queue->addShape($qshape2, SWFBUTTON_DOWN|SWFBUTTON_OVER);
	
	my $queueText= new SWF::Text();
	$queueText->setFont($font);
	$queueText->setHeight(12);
	$queueText->setColor(0,0,0);
	$queueText->addString("Queue");
		
	$a = new SWF::Action("loadMovie('queue-' + _name + '.swf', 'queue');");
	$btn_queue->addAction($a, SWFBUTTON_MOUSEUP);

	

	
	# Mobile Node showRoutingTable button
	my $btn_rtable = new SWF::Button();	
	my $rtshape  = &makerect(0xff, 0xcc, 0x66, 0xff, 18,12,1);
	my $rtshape2 = &makerect(0xff, 0xff, 0xff, 0xff, 18,12,1);
	$btn_rtable->addShape($rtshape, SWFBUTTON_UP|SWFBUTTON_HIT);
	$btn_rtable->addShape($rtshape2, SWFBUTTON_DOWN|SWFBUTTON_OVER);
	
	my $rtableText= new SWF::Text();
	$rtableText->setFont($font);
	$rtableText->setHeight(12);
	$rtableText->setColor(0,0,0);
	$rtableText->addString("RT");

  # Two actions for the RT-Button. Both call gettable.pl
	# 1. Loads a swf-file that contains a formatted table. 
	# 2. Loads a xml-file so flasplayer can paint routes.
	open(ASCODE,"route.as") or sendError("Couldn't load route.as .");
	my @asrcode =<ASCODE>;
	close(ASCODE);	
	$a = new SWF::Action("
	@asrcode
");
	$btn_rtable->addAction($a, SWFBUTTON_MOUSEUP);
	
	# Mobile Node showNeighborTable button
	my $btn_ntable = new SWF::Button();	
	$btn_ntable->addShape($rtshape, SWFBUTTON_UP|SWFBUTTON_HIT);
	$btn_ntable->addShape($rtshape2, SWFBUTTON_DOWN|SWFBUTTON_OVER);
	
	my $ntableText= new SWF::Text();
	$ntableText->setFont($font);
	$ntableText->setHeight(12);
	$ntableText->setColor(0,0,0);
	$ntableText->addString("NT");
	
	# loads an xmlfile from gettable.pl and do the xmlparsing and painting in flashplayer
	open(ASCODE,"neighbor.as") or sendError("Couldn't load neighbor.as .");
	my @asncode =<ASCODE>;
	close(ASCODE);
	$a = new SWF::Action("time=_root.viewport.view._currentFrame/$framefreq;
  //the rest is loaded from file neighbor.as
	@asncode
");
	$btn_ntable->addAction($a, SWFBUTTON_MOUSEUP);
	
				
	# put all for a node into a movieclip  
	my $clip = new SWF::MovieClip();
	
	# loads an xmlfile from gettable.pl and do the xmlparsing and painting in flashplayer
	open(ASCODE,"loops.as") or sendError("Couldn't load loops.as .");
	my @ascode =<ASCODE>;
	close(ASCODE);
	$clip->add(new SWF::Action("stop(); @ascode"));
	
	my $nodeButton_inst = $clip->add($nodebutton);
	my $textField_inst = $clip->add($textField);
	$textField_inst->moveTo(6,-6);
	$clip->nextFrame(); #frame 1 ok
	
	# move the ID a little bit up-left
	$nodeButton_inst->remove();
	$textField_inst->move(-8,-4);
	
	# nodemenu
	# Mobile Node menu-background
	my $menushape = &makerect(0xff, 0xff, 0xee, 0xff, 215, 30,1);
	my $menu_inst = $clip->add($menushape);
	
	my $closeButton = $clip->add($btn2);
	
	# Mobile Node place queue-, routingtable- and neighborbutton
	my $queueButton = $clip->add($btn_queue);
	$queueButton->move(13,2);
	my $queueText_inst = $clip->add($queueText);
	$queueText_inst->move(15,12);

	my $ntableButton = $clip->add($btn_ntable);
	$ntableButton->move(35,16);
	my $ntableText_inst = $clip->add($ntableText);
	$ntableText_inst->move(37,27);
		
	my $rtableButton = $clip->add($btn_rtable);
	$rtableButton->move(13,16);
	my $rtableText_inst = $clip->add($rtableText);
	$rtableText_inst->move(15,27);
	
		
	my $samplesshape = &makerect(0xff, 0xcc, 0x66, 0xff, 15,12,1);
	my $samplesshape2 = &makerect(0xff, 0xff, 0xff, 0xff, 15,12,1);
	
	# $nn is global variable
	for(my $i=0;$i<$nn;$i++) {
		my $btn_samples = new SWF::Button();
		$btn_samples->addShape($samplesshape, SWFBUTTON_UP|SWFBUTTON_HIT);
		$btn_samples->addShape($samplesshape2, SWFBUTTON_DOWN|SWFBUTTON_OVER);
	
		my $samplesText= new SWF::Text();
		$samplesText->setFont($font);
		$samplesText->setHeight(12);
		$samplesText->setColor(0,0,0);
		$samplesText->addString("$i");
	
		# This is errortolerant, if file not exist (no samples of this neighbor available) -> nothing happens 	
		$a = new SWF::Action("loadMovie('samples-' + _name + '-$i.swf', 'queue');");
		$btn_samples->addAction($a, SWFBUTTON_MOUSEUP);
		my $btn_samplesinst = $clip->add($btn_samples);
		my $samplesText_inst = $clip->add($samplesText);
		if ($i >= $nn/2){
			$btn_samplesinst->move(58+($i-$nn/2)*15,16);
			$samplesText_inst->move(59+($i-$nn/2)*15,26);
		}
		else{
			$btn_samplesinst->move(58+$i*15,2);
			$samplesText_inst->move(59+$i*15,12);
		}
	}	
	
	
	my $empty_inst = $clip->add($empty);
	$empty_inst->setName('queue');
	$empty_inst->moveTo(0,30);
	$clip->nextFrame(); #frame 2 ok
	
	return $clip;
}

=head2

returns a simple Text-Object (internal)

=cut
sub makeText{
	my($text,$h,$r,$g,$b)=@_;
	#default values
	$r=0 unless defined $r;
	$g=0 unless defined $g;
	$b=0 unless defined $b;
	
	my $t= new SWF::Text();
		$t->setFont($font);
		$t->setHeight($h);
		$t->setColor($r,$g,$b);
		$t->addString($text);
	return $t;
}

#The webpage that contains the flashmovie. I should put there the static things so that flash not need to render this. 
#A nice table with simulationparameters and stats maybe..  	
sub makeHTML {
	my ($Sekunden, $Minuten, $Stunden, $Monatstag, $Monat,$Jahr, $Wochentag, $Jahrestag, $Sommerzeit) = localtime(time);
	$Monat+=1;
	$Jahrestag+=1;
	$Monat = $Monat < 10 ? $Monat = "0".$Monat : $Monat;
	$Monatstag = $Monatstag < 10 ? $Monatstag = "0".$Monatstag : $Monatstag;
	$Stunden = $Stunden < 10 ? $Stunden = "0".$Stunden : $Stunden;
	$Minuten = $Minuten < 10 ? $Minuten = "0".$Minuten : $Minuten;
	$Sekunden = $Sekunden < 10 ? $Sekunden = "0".$Sekunden : $Sekunden;
	$Jahr+=1900;

	my $html="traceview.html";
	my $swf =$tracefilename.'.swf';
	open(HTML,">$dir/$html") or &sendError("Couldn't create/write file $html. Please control file and directory permissions, place on disk/partition, etc. \n");

print HTML <<EOF; 
<HTML>
<HEAD>
<TITLE>NS-2 TraceView $version</TITLE>
</HEAD>
<BODY bgcolor="#EEEEEE">
<CENTER><H2>NS-2 Traceview $version</H2></CENTER>
<center><H3>date: $Monatstag.$Monat.$Jahr Area: $xsize m x $ysize m</H3><center>
<CENTER><OBJECT classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" 
  codebase="http://active.macromedia.com/flash2/cabs/swflash.cab#version=4,0,0,0"
  ID=trace WIDTH=$moviex HEIGHT=$moviey>
 <PARAM NAME=movie VALUE="$swf"> 
 <PARAM NAME=quality VALUE=high> 
 <PARAM NAME=bgcolor VALUE=#FFFFFF> 
 <EMBED src="$swf" 
 quality=high 
 bgcolor=#FFFFFF  
 WIDTH=$moviex 
 HEIGHT=$moviey 
 TYPE="application/x-shockwave-flash" 
 PLUGINSPAGE="http://www.macromedia.com/shockwave/download/index.cgi?P1_Prod_Version=ShockwaveFlash"></EMBED>
</OBJECT></CENTER>
</BODY>
</HTML>
EOF

close(HTML);
}

sub sendIntro {
	my $text = shift;
	if ($isweb) {
		print '<HTML><BODY><H1 align="center">Hi, this is NS-2 TraceView '.$version.' webfrontend.</H1><P align="center"><IMG SRC="../pic.jpeg" ALT="NS-2 TraceView logo"></P>';
		print '<B><PRE>'.$text.'</PRE></B>';
		print '<P ALIGN="center"><A HREF="http://www.ifn.et.tu-dresden.de/~liscov/traceview/">www.ifn.et.tu-dresden.de/~liscov/traceview</A></P></BODY></HTML>';
		exit();
	} 
	else {
		print "$text\n";
		die("I will kill me now ..\n");
	}
}

sub sendError {
	my $errortext = shift;
	if ($isweb) {
		print '<HTML><BODY><H1>Ups, an error.</H1><P>This is the error message:</P> <B><PRE>'.$errortext.'</PRE></B><P><A HREF="/">home</A></P></BODY></HTML>';
		exit();
	} 
	else {
		print "$errortext\n";
		die("I will kill me now ..\n");
	}
}

=back

=head1 AUTHOR

Peter Liscovius 
	
	email: peter.liscovius@mailbox.tu-dresden.de
	www  : http://peter.liscovius.de
		
Started work on this by frustration with "nam" and crawling through tracefiles.  

=cut
