#!/usr/bin/perl -w
use strict;

use lib("/aodv/bin");
use TraceStat;

if (!$ARGV[0]) {die("Give me a file as parameter.\n\n");}
my $file=$ARGV[0];

# simple untainting
$file=~ s/[^A-Za-z0-9_\/\-\.]//;

if (!(-r $file)) {die("$file doesn't exist.\n"); }

my $stat  = new TraceStat;
#my $stat2 = new TraceStat;
$stat->makeStat($file);
#$stat2->makeStat($file.'.stat');

$stat->saveAsText($file.'.stat');
$stat->saveAsXML($file.'.xml');


# sample output:
print "CBR send     Packets: ".$stat->{AGT_CBR}{s}." packets\n";
print "CBR send     Bytes  : ".$stat->{AGT_CBR}{sB}." bytes\n";
print "CBR received Packets: ".$stat->{AGT_CBR}{r}." packets\n";
print "CBR received Bytes  : ".$stat->{AGT_CBR}{rB}." bytes\n";
print "\n";

# sample output:
print "TCP send     Packets: ".$stat->{AGT_TCP}{s}." packets\n";
print "TCP send     Bytes  : ".$stat->{AGT_TCP}{sB}." bytes\n";
print "TCP received Packets: ".$stat->{AGT_TCP}{r}." packets\n";
print "TCP received Bytes  : ".$stat->{AGT_TCP}{rB}." bytes\n";
print "\n";
